import time

import pyautogui
import pyperclip
from selenium.webdriver import Keys
from selenium.webdriver.support.select import Select
from selenium.webdriver.support.wait import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC

from Util.Util import DriverUtils
import logging


# from common.utils import DriverTools



class BasePage:

    def __init__(self):
        self.driver = DriverUtils.get_web_driver()


    # 查找元素
    def find_el(self, loc, time=10, fre=0.5):
        ele = WebDriverWait(self.driver, time, fre).until(lambda x: x.find_element(*loc))
        return ele

    def find_son_elements(self, ele, loc):
        elements = ele.find_elements(*loc)
        return elements

    # 输入文本内容
    def input_text_by_loc(self, loc, value):
        # 定义该元素对于的文本
        ele = self.find_el(loc)
        # 先清空
        # ele.clear()
        # 使用 JavaScript 强制清空输入框中的文本
        # self.driver.execute_script("arguments[0].value = '';", ele)
        # 使用键盘操作选中并删除文本
        time.sleep(1)
        ele.send_keys(Keys.CONTROL + "a")  # 选中所有文本
        ele.send_keys(Keys.DELETE)  # 删除选中的文本
        # 再输入
        ele.send_keys(value)

    def input_text_by_ele(self, ele, value):
        # 定义该元素对于的文本
        # 先清空
        time.sleep(1)
        ele.clear()
        # 再输入
        ele.send_keys(value)

    # 滚动条
    def scroll(self, x, y):
        # 横着滚动调整x值，竖着滚动调整y值
        js = "window,scroll({},{})".format(x, y)
        self.driver.execute_script(js)

    # 下拉框选择
    def select_text(self, loc, text):
        # 定位该下拉框对应的元素
        ele = self.find_el(loc)
        # 实例化Select对象
        sle = Select(ele)
        # 调用select选择方法
        sle.select_by_visible_text(text)

    def get_text_loc(self,loc):
        return self.find_el(loc).get_attribute("innerText")

    def get_text_ele(self, ele):
        return ele.get_attribute("innerText")
    # 选择文件
    def select_document(self,path_str=None):
        time.sleep(1)
        pyperclip.copy("D:")  # 将路径字符串复制到剪贴板
        time.sleep(1)
        pyautogui.hotkey('ctrl', 'v')  # 模拟粘贴操作
        time.sleep(1)
        pyautogui.press('enter')  # 模拟按下回车键
        time.sleep(1)

        time.sleep(1)
        pyperclip.copy("txt")  # 将路径字符串复制到剪贴板
        time.sleep(1)
        pyautogui.hotkey('ctrl', 'v')  # 模拟粘贴操作
        time.sleep(1)
        pyautogui.press('enter')  # 模拟按下回车键

        pyperclip.copy(path_str)  # 将路径字符串复制到剪贴板
        time.sleep(1)
        pyautogui.hotkey('ctrl', 'v')  # 模拟粘贴操作
        time.sleep(1)
        pyautogui.press('enter')  # 模拟按下回车键
        time.sleep(2)

    # # 设置日志记录器
    # def set_logger(self):
    #     # 检查记录器是否已经存在，如果存在，则直接返回
    #     if self.logger:
    #         return
    #
    #     logging.basicConfig(level=logging.INFO)
    #     self.logger = logging.getLogger(__name__)
    #     # 创建一个处理程序，用于输出到控制台
    #     console_handler = logging.StreamHandler()
    #     console_handler.setLevel(logging.INFO)
    #     # 创建一个处理程序，用于输出到文件
    #     self.file_handler = logging.FileHandler('business_knowledge1.log', encoding='utf-8')
    #     self.file_handler.setLevel(logging.INFO)
    #     # 创建一个格式化器，用于设置日志格式
    #     formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')
    #     # 将格式化器添加到处理程序
    #     console_handler.setFormatter(formatter)
    #     self.file_handler.setFormatter(formatter)
    #     # 先清空已有的处理程序
    #     self.logger.handlers.clear()
    #     # 检查记录器中是否已经存在相同类型的处理程序，如果不存在，则添加
    #     if console_handler not in self.logger.handlers:
    #         self.logger.addHandler(console_handler)
    #     if self.file_handler not in self.logger.handlers:
    #         self.logger.addHandler(self.file_handler)
    #     print(len(self.logger.handlers))
    #
    # def log_info(self, message):
    #     self.logger.info(message)
    # #
    # def close_logger(self):
    #     self.file_handler.close()


