from selenium.webdriver.common.by import By

from Pages.businessKnowledge_page import BusinessKnowledgePage
from Pages.login_page import LoginPage
from Util.Util import DriverUtils
import time
from loguru import  logger


class TestBusinessKnowledge:
    def setup_class(self):
        # 在所有的测试用例脚本之前执行一次
        # 完成公共部分初始化
        self.driver = DriverUtils.get_web_driver()
        self.login_page = LoginPage()
        self.business_page = BusinessKnowledgePage()
    def teardown_class(self):
        # 在所有的测试用例脚本之后执行一次
        self.driver.quit()
        pass

    def setup_method(self):
        # 在每个测试用例脚本之前执行一次
        self.driver.get('https://rays7.raysgo.com/login')
        self.login_page.login_username("17373027967","3149390154Li")
        self.business_page.entranceAi()  # 进入AI编辑室
        self.business_page.entranceBusinessKnowledge()  # 进入企业知识库
        time.sleep(3)

    def teardown_method(self):
        # 在每个测试用例脚本之后执行一次
        pass

    # 新建文件夹 0-20 重复文件名
    def test_newFolder_case001(self):
        folder_name = "XXXXX"
        self.business_page.newFolderControl(folder_name)
        time.sleep(3)
        # 断言
        folders = self.business_page.find_el(self.business_page.folders).find_elements(By.XPATH,".//span")
        assert folder_name == self.business_page.get_text_ele(folders[(len(folders)-1)])
        logger.info("新建文件成功")

    # 更新文件夹名字 0-20 重复文件名
    def test_updateFolder_case001(self):
        expect_folder_name = "xxxx322x"
        actual_folder_name = self.business_page.updateFolderControl(expect_folder_name)
        time.sleep(2)
        # 断言
        assert actual_folder_name == expect_folder_name
        logger.info("更新文件名字成功")

    # 删除文件夹
    def test_deleteFolder_case001(self):
        self.business_page.deleteFolderControl()



    # 切换文件夹
    def test_traverse_folder(self):
        try:
            self.business_page.traverseFolder()
            assert 1 == 1
        except Exception as e:
            logger.info("错误类型：{e}")

    # 搜索
    def test_search_document(self, key_name = "世界"):
        try:
            documents = self.business_page.searchDocument(key_name)
            flag = self.business_page.isExistKeyInDocument(key_name,documents)
            assert flag == True
        except Exception as e:
            logger.info(f"发生报错：报错信息为{e}")

    # 文档上传
    def test_upload_document_case001(self):
        stry_paths = []
        stry_paths.append("t"+str(0+1)+".txt")
        self.business_page.upload_document_helper.uploadDocumentControl(stry_paths)
        time.sleep(10)
        # 断言
        assert "学习成功" == self.business_page.get_text_ele(self.business_page.document_list_helper.firstDocument)

    # 导入网站
    def test_upload_website_case001(self):
        self.business_page.upload_document_helper.uploadUrlControl("https://blog.csdn.net/FezZZZ/article/details/120878765")
        time.sleep(10)
        # 断言
        assert "学习成功" == self.business_page.get_text_ele(self.business_page.document_list_helper.firstDocument)


